<?php
/*
  $Id: ezship.php, v1.0, 2006/11/23$
  Author: Light Tseng
  http://www.ezeshop.com.tw/
*/

  class ezship {
    var $code, $title, $description, $icon, $enabled;

    function ezship() {
      global $order;

      $this->code = 'ezship';
      $this->title = MODULE_SHIPPING_EZSHIP_TEXT_TITLE;
      $this->description = MODULE_SHIPPING_EZSHIP_TEXT_DESCRIPTION.$this->author();
      $this->sort_order = MODULE_SHIPPING_EZSHIP_SORT_ORDER;
      $this->icon = DIR_WS_ICONS . 'ezship.gif';
      $this->tax_class = MODULE_SHIPPING_EZSHIP_TAX_CLASS;
      $this->enabled = ((MODULE_SHIPPING_EZSHIP_STATUS == 'True') ? true : false);

      if ( ($this->enabled == true) && ((int)MODULE_SHIPPING_EZSHIP_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_SHIPPING_EZSHIP_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->delivery['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function quote($method = '') {
      global $order, $PHP_SELF, $HTTP_POST_VARS;

      $add_str='';
      if(basename($PHP_SELF)==FILENAME_CHECKOUT_SHIPPING && ($HTTP_POST_VARS['action'] != 'process') ) {
        $add_str='<br>'.MODULE_SHIPPING_EZSHIP_TEXT_NOTICE;
      }
      $this->quotes = array('id' => $this->code,
                            'module' => MODULE_SHIPPING_EZSHIP_TEXT_TITLE,
                            'methods' => array(array('id' => $this->code,
                                                     'title' => MODULE_SHIPPING_EZSHIP_TEXT_WAY.$add_str,
                                                     'cost' => MODULE_SHIPPING_EZSHIP_COST)));

      if ($this->tax_class > 0) {
        $this->quotes['tax'] = tep_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);
      }

      if (tep_not_null($this->icon)) $this->quotes['icon'] = tep_image($this->icon, $this->title);

      return $this->quotes;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_SHIPPING_EZSHIP_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function author() {
      return '<div align=right><a href="http://www.ezeshop.com.tw/ezeshop/product_info.php?products_id=81" target="_new"><img align=top border=0 alt="EZeShop" src="http://www.ezeshop.com.tw/ezeshop/images/bloglogo1.gif?ezship"></a></div>';
    }  

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('ҰʨfWӿ', 'MODULE_SHIPPING_EZSHIP_STATUS', 'True', 'Do you want to offer flat rate shipping?', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('fBO', 'MODULE_SHIPPING_EZSHIP_COST', '50', 'The shipping cost for all orders using this shipping method.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('|O', 'MODULE_SHIPPING_EZSHIP_TAX_CLASS', '0', 'Use the following tax class on the shipping fee.', '6', '0', 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('ϥΦa', 'MODULE_SHIPPING_EZSHIP_ZONE', '0', 'If a zone is selected, only enable this shipping method for that zone.', '6', '0', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ܱƧ', 'MODULE_SHIPPING_EZSHIP_SORT_ORDER', '0', 'Sort order of display.', '6', '0', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_SHIPPING_EZSHIP_STATUS', 'MODULE_SHIPPING_EZSHIP_COST', 'MODULE_SHIPPING_EZSHIP_TAX_CLASS', 'MODULE_SHIPPING_EZSHIP_ZONE', 'MODULE_SHIPPING_EZSHIP_SORT_ORDER');
    }
  }
?>
